## irstlm 6.00.05

=== CMakeLists.txt ===
#CMake 2.6+ is recommended to an improved Boost module
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

PROJECT (irstlm)

SET(IRSTLM_VERSION_MAJOR "5")
SET(IRSTLM_VERSION_MINOR "80")
SET(IRSTLM_VERSION_PATCH "08")

SET(CMAKE_C_COMPILER "gcc" )
SET(CMAKE_CXX_COMPILER "g++" )

OPTION(CXX0 "Enable/Disable std=c++0" ON)
OPTION(ASSERT "Enable/Disable MY_ASSERT_FLAG" ON)

MATH(EXPR IRSTLM_INT_VERSION "(${IRSTLM_VERSION_MAJOR} * 10000) + (${IRSTLM_VERSION_MINOR} * 100) + (${IRSTLM_VERSION_PATCH} * 1)" )

SET(IRSTLM_VERSION "${IRSTLM_VERSION_MAJOR}.${IRSTLM_VERSION_MINOR}.${IRSTLM_VERSION_PATCH}")

#ADD_DEFINITIONS(-DPS_CACHE_ENABLE)

IF(COMMAND cmake_policy)
  cmake_policy(SET CMP0017 NEW)
ENDIF(COMMAND cmake_policy)

IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    SET(CMAKE_INSTALL_PREFIX
        "${CMAKE_SOURCE_DIR}/inst" CACHE PATH "IRSTLM install prefix" FORCE
        )
    MESSAGE(STATUS "You have not set the install dir, default to ${CMAKE_INSTALL_PREFIX}, if
    you want to set it, use cmake -DCMAKE_INSTALL_PREFIX to do so")
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

#set various platform specific global options
IF(WIN32)
 SET(CMAKE_DEBUG_POSTFIX "d")
 OPTION( USE_64_BIT "Set to on if you want to compile Win64" OFF )
ENDIF(WIN32)


# include specific modules
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (scripts)
ADD_SUBDIRECTORY (doc)

IF (WIN32)
MESSAGE( STATUS "-------------------------------------------------------------------------------" )
MESSAGE( STATUS "USE_64_BIT = ${USE_64_BIT}" )
MESSAGE( STATUS "Change a value with: cmake -D<Variable>=<Value>" )
MESSAGE( STATUS "-------------------------------------------------------------------------------" )


SET( USE_64_BIT "${USE_64_BIT}" CACHE BOOL
    "Set to ON to build Win64" FORCE )
ENDIF()

=== doc/CMakeLists.txt ===
# include specific modules

INCLUDE(UseLATEX OPTIONAL)

if (PDFLATEX_COMPILER AND BIBTEX_COMPILER AND MAKEINDEX_COMPILER)
message("PDFLATEX_COMPILER exists (${PDFLATEX_COMPILER})")
message("BIBTEX_COMPILER exists (${BIBTEX_COMPILER})")
message("MAKEINDEX_COMPILER exists (${MAKEINDEX_COMPILER})")


SET(LATEX_OUTPUT_PATH build)

PROJECT(irstlm-manual NONE)
cmake_minimum_required(VERSION 2.8)

SET(IRSTLM_INPUT_TEX ClassAndChunkLMs.tex LMFileFormats.tex LMFiltering.tex LMInterface.tex LMInterpolation.tex LMPruning.tex LMQuantization.tex LMAdaptation.tex LMCompilation.tex LMPrune.tex LMSmoothing.tex compileLM.tex dict.tex gettingStarted.tex giganticLM.tex installation.tex interpolateLM.tex interpolatedLM.tex introduction.tex mixtureLM.tex ngt.tex parallelComputation.tex pruneLM.tex quantizeLM.tex referenceMaterial.tex regressionTests.tex releaseNotes.tex tlm.tex )

ADD_LATEX_DOCUMENT(
    ./irstlm-manual.tex
    INPUTS ${IRSTLM_INPUT_TEX}
    DEFAULT_PDF
)

add_custom_command(TARGET pdf POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
       ${CMAKE_CURRENT_BINARY_DIR}/${LATEX_OUTPUT_PATH}/irstlm-manual.pdf
       ${CMAKE_BINARY_DIR}/doc/irstlm-${IRSTLM_VERSION}-manual.pdf)

INSTALL(PROGRAMS irstlm-${IRSTLM_VERSION}-manual.pdf
    DESTINATION doc
    PERMISSIONS OWNER_READ
    )

ELSE()
message("PDFLATEX_COMPILER does not exists")
ENDIF()

=== scripts/CMakeLists.txt ===
INSTALL(PROGRAMS
    add-start-end.sh build-lm-qsub.sh build-lm.sh build-sublm.pl goograms2ngrams.pl lm-stat.pl mdtsel.sh merge-sublm.pl ngram-split.pl rm-start-end.sh sort-lm.pl split-dict.pl split-ngt.sh wrapper 
    DESTINATION bin
    PERMISSIONS OWNER_EXECUTE OWNER_READ OWNER_WRITE
    )

=== src/CMakeLists.txt ===
# Set output directory
SET(EXECUTABLE_OUTPUT_PATH ${CMAKE_INSTALL_PREFIX}/bin)
SET(LIBRARY_OUTPUT_PATH ${CMAKE_INSTALL_PREFIX}/lib)

ADD_DEFINITIONS("-D_LARGE_FILES")
ADD_DEFINITIONS("-D_FILE_OFFSET_BITS=64")
ADD_DEFINITIONS("-DMYCODESIZE=3")
ADD_DEFINITIONS("-DDEBUG")

if (TRACE_LEVEL)
  ADD_DEFINITIONS("-DTRACE_LEVEL=${TRACE_LEVEL}")
endif()

if (OPTION)
  ADD_DEFINITIONS("-DOPTION_${OPTION}")
endif()

if (SOLUTION)
  ADD_DEFINITIONS("-DSOLUTION_${SOLUTION}")
endif()

if (CXX0)
  MESSAGE( STATUS "HAVE_CXX0=true; hence, variable HAVE_CXX0 is set" )
  SET(STD_FLAG "-std=c++0x")
  ADD_DEFINITIONS("-DHAVE_CXX0")
else()
  MESSAGE( STATUS "HAVE_CXX0=false; hence, variable HAVE_CXX0 is unset" )
  SET(STD_FLAG "")
  ADD_DEFINITIONS("-UHAVE_CXX0")
endif() 

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g ${STD_FLAG} -isystem/usr/include -W -Wall -ffor-scope")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")

INCLUDE_DIRECTORIES("${PROJECT_SOURCE_DIR}/src")

SET( LIB_IRSTLM_SRC
        cmd.h cmd.c
        thpool.h thpool.c
        gzfilebuf.h index.h
        dictionary.h dictionary.cpp
        htable.h htable.cpp 
        lmContainer.h lmContainer.cpp 
        lmclass.h lmclass.cpp 
        lmmacro.h lmmacro.cpp
        lmtable.h lmtable.cpp
        lmInterpolation.h lmInterpolation.cpp
        mempool.h mempool.cpp 
        mfstream.h mfstream.cpp 
        n_gram.h n_gram.cpp 
        ngramcache.h ngramcache.cpp
        ngramtable.h ngramtable.cpp
        timer.h timer.cpp 
        util.h util.cpp 
        crc.h crc.cpp 
	interplm.h interplm.cpp
        linearlm.h linearlm.cpp
        mdiadapt.h mdiadapt.cpp 
        mixture.h mixture.cpp 
        normcache.h normcache.cpp 
        shiftlm.h shiftlm.cpp
        cplsa.h cplsa.cpp 
        cswam.h cswam.cpp 
        doc.h doc.cpp
)

ADD_LIBRARY(irstlm STATIC ${LIB_IRSTLM_SRC})
LINK_DIRECTORIES (${LIBRARY_OUTPUT_PATH})

FOREACH(CMD dict ngt tlm dtsel plsa cswa compile-lm interpolate-lm prune-lm quantize-lm score-lm verify-caching)

ADD_EXECUTABLE(${CMD} ${CMD}.cpp)
TARGET_LINK_LIBRARIES (${CMD} irstlm -lm -lz -lpthread)

ENDFOREACH()

#INSTALL INCLUDE FILES
FILE(GLOB includes src *.h)
INSTALL(FILES ${includes} DESTINATION include)

add_custom_command(OUTPUT LNS
                   COMMAND ln -s -f -n lib lib64
		   WORKING_DIRECTORY ${CMAKE_INSTALL_PREFIX}
                   COMMENT "creating link from lib to lib64")

add_custom_target(LinkToLib64 ALL DEPENDS LNS)

## irstlm 5.80.03

=== debian/changelog ===
irstlm (5.80.03-2) unstable; urgency=medium

  * Install headers in /usr/include/irstlm.
    Closes: #812742, #813093.

 -- Giulio Paci <giuliopaci@gmail.com>  Tue, 26 Jan 2016 14:31:34 +0100

irstlm (5.80.03-1) unstable; urgency=medium

  [Giulio Paci]
  * Initial release.
    Closes: #671282.

  [Balint Reczey]
  * Build-depend on default automake
  * Convert packaging to use Debhelper
  * Add myself to uploaders
  * Convert to multiarch
  * Drop debug package
  * Drop control.in
  * Install bash-completion rules to proper location
  * Update standards version
  * Drop unused copyright info

 -- Balint Reczey <balint@balintreczey.hu>  Sun, 20 Dec 2015 14:09:20 +0100

=== debian/control ===
Source: irstlm
Section: text
Priority: optional
Maintainer: Giulio Paci <giuliopaci@gmail.com>
Uploaders: Koichi Akabe <vbkaisetsu@gmail.com>,
           Balint Reczey <balint@balintreczey.hu>
Build-Depends: dh-autoreconf,
 devscripts,
 libtool,
 automake,
 autoconf,
 debhelper (>= 9~),
 dh-buildinfo,
 zlib1g-dev,
 dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/irstlm.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/irstlm.git
Homepage: https://sourceforge.net/projects/irstlm/

Package: irstlm
Architecture: any
Depends: libirstlm0 (= ${binary:Version}),
	 ${shlibs:Depends},
	 ${misc:Depends},
	 ${perl:Depends},
	 perl
Description: IRST Language Modeling Toolkit
 The IRST Language Modeling Toolkit can be used to learn a language model
 from data. The generated n-gram models should be usable on any system
 supporting ARPA language model format.
 .
 This package provides the command line tools.

Package: libirstlm-dev
Section: libdevel
Architecture: any
Depends: libirstlm0 (= ${binary:Version}),
         ${misc:Depends}
Description: IRST Language Modeling Toolkit - development files
 The IRST Language Modeling Toolkit can be used to learn a language model
 from data. The generated n-gram models should be usable on any system
 supporting ARPA language model format.
 .
 This package provides development headers for IRSTLM.

Package: libirstlm0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: IRST Language Modeling Toolkit - runtime library
 The IRST Language Modeling Toolkit can be used to learn a language model
 from data. The generated n-gram models should be usable on any system
 supporting ARPA language model format.
 .
 This package contains the IRSTLM shared library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared --includedir=/usr/include/irstlm

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
http://sf.net/irstlm/irstlm-(\d.+)\.(?:tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## irstlm 6.00.05

=== debian/changelog ===
irstlm (6.00.05-2) unstable; urgency=medium

  * Add missing LPPL license to copyright.
    Closes: #824455
  * Add path command to irstlm wrapper script.
  * Change maintainer to Debian Science Maintainers
    <debian-science-maintainers@lists.alioth.debian.org>
  * Updated Vcs-* fields in control.
    The repository has been moved to debian-science.

 -- Giulio Paci <giuliopaci@gmail.com>  Tue, 17 May 2016 09:45:14 +0200

irstlm (6.00.05-1) unstable; urgency=medium

  * New upstream version 6.00.05.
  * Update watch file.
    Project has migrated to github.
  * Bump Standards-Version to 3.9.8.
    No changes needed.
  * Update Vcs-* fields in control.
    Secure urls are now used.
  * Update Homepage field in control.
    Project has an homepage at FBK site.
  * Change Section from text to science.
  * Update Source field in copyright.
    Project has migrated to github.
  * Drop 1001_fix_compilation_warnings.patch and
    compilation_fixes.patch.
  * Add 1001_fix_build_issues.patch, 1003_fix_online_help.patch
    and 1004_do_not_install_private_scripts.patch.
  * Update 1002_fix_problems_identified_by_cppcheck.patch.
  * Drop irstlm.lintian-overrides.
  * Rename libirstlm0 package into libirstlm1.
  * Remove --includedir configure flag.
    This option is not needed with provided patches.
  * Update bash completion file.
  * Handle bash completion installation with irstlm.bash-completion.
    - Add bash-completion to Build-Depends.
    - Add irstlm.bash-completion.
    - Update irstlm.install.
    - Use --with bash-completion dh option.
  * Implement a workaround to handle plsa and plsa.sh in irstlm and
    update_completion.

 -- Giulio Paci <giuliopaci@gmail.com>  Fri, 06 May 2016 01:40:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,28 @@
 Source: irstlm
-Section: text
+Section: science
 Priority: optional
-Maintainer: Giulio Paci <giuliopaci@gmail.com>
-Uploaders: Koichi Akabe <vbkaisetsu@gmail.com>,
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Giulio Paci <giuliopaci@gmail.com>,
+           Koichi Akabe <vbkaisetsu@gmail.com>,
            Balint Reczey <balint@balintreczey.hu>
 Build-Depends: dh-autoreconf,
  devscripts,
  libtool,
  automake,
  autoconf,
+ bash-completion,
  debhelper (>= 9~),
  dh-buildinfo,
  zlib1g-dev,
  dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/irstlm.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/irstlm.git
-Homepage: https://sourceforge.net/projects/irstlm/
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/irstlm.git
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/irstlm.git
+Homepage: http://hlt-mt.fbk.eu/technologies/irstlm
 
 Package: irstlm
 Architecture: any
-Depends: libirstlm0 (= ${binary:Version}),
+Depends: libirstlm1 (= ${binary:Version}),
 	 ${shlibs:Depends},
 	 ${misc:Depends},
 	 ${perl:Depends},
@@ -35,7 +37,7 @@
 Package: libirstlm-dev
 Section: libdevel
 Architecture: any
-Depends: libirstlm0 (= ${binary:Version}),
+Depends: libirstlm1 (= ${binary:Version}),
          ${misc:Depends}
 Description: IRST Language Modeling Toolkit - development files
  The IRST Language Modeling Toolkit can be used to learn a language model
@@ -44,7 +46,7 @@
  .
  This package provides development headers for IRSTLM.
 
-Package: libirstlm0
+Package: libirstlm1
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 export DEB_CFLAGS_MAINT_APPEND = -Wall
 
 %:
-	dh $@ --with autoreconf
+	dh $@ --with autoreconf --with bash-completion
 
 override_dh_auto_configure:
-	dh_auto_configure -- --enable-shared --includedir=/usr/include/irstlm
+	dh_auto_configure -- --enable-shared

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/irstlm-$1\.tar\.gz/ \
	https://github.com/irstlm-team/irstlm/tags .*/v?(\d\S*)\.tar\.gz
